<?php
############ Keys and Dirs ############
$directorysAndKeys = array(
    array('dir' => '', 'key' => '', 'docTypeId' => ''),
    array('dir' => '', 'key' => '', 'docTypeId' => ''),
    array('dir' => '', 'key' => '', 'docTypeId' => ''),
    array('dir' => '', 'key' => '', 'docTypeId' => ''),
    array('dir' => '', 'key' => '', 'docTypeId' => ''),
);
############ Instllningar ############
$ToPatient		= TRUE;
$Loop			= TRUE;
$maxFileSize	= 20; //in Mb
$fileAge		= 5;  //in seconds
$sleep			= 5;  //in seconds
######################################
function CurlSendFile($file, $TokenKey, $docTypeId) {
    global $ToPatient;
    if($ToPatient)
        $ToPatientString = "true";
    else
        $ToPatientString = "false";
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_SSLVERSION, FALSE);
    curl_setopt($ch, CURLOPT_URL,
        "https://webdoc.atlan.se/upload.php?action=http_upload".
        "&SecurityKey=$TokenKey".
        "&ToPatient=$ToPatientString".
        "&DocTypeID=$docTypeId");
		
	curl_setopt($ch, CURLOPT_PORT, 443);
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	$post = array("image" => '@'.$file);
	//$post = array("image" => new \CURLFile($file));
	//curl_setopt($ch, CURLOPT_SAFE_UPLOAD, true);
		
	curl_setopt($ch, CURLOPT_POSTFIELDS, $post);

	curl_exec($ch);

    if(curl_errno($ch)) {
        echo curl_error($ch);
        return FALSE;
    } else {
        $CurlStatus = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        echo "CURL: ".$CurlStatus."\n";
        if($CurlStatus == 200)
            return TRUE;
        else
            return FALSE;
    }
    return FALSE;
}
function ScanDirSend(array $clinic, $maxFileSize) {
	global $fileAge, $sleep;
    $Extensions = array("jpg","JPG","jpeg","JPEG","png","bmp","tga","pdf","PDF","tif","gif","GIF");
    $files = glob($clinic['dir'].'*');
    array_multisort( array_map( 'filemtime', $files ), SORT_NUMERIC, SORT_ASC, $files);
    foreach($files as $file) {
        $pathinfo = pathinfo($file);
		$howOld = time() - filemtime($file);

		if (filesize($file) > $maxFileSize * 1000000) {
			echo "$file: FEL: filen kunde inte skickas, maximal filstorlek $maxFileSize Mb\n";
			continue;
		}

		if (!in_array($pathinfo['extension'], $Extensions)) {
			continue;
		}

        $howOld = time() - filemtime($file);
		if ($howOld < $fileAge) {
			continue;
		}

        if(CurlSendFile($file, $clinic['key'], $clinic['docTypeId'])) {
            echo $file.": OK: filen skickades till Webdoc."."\n";
            unlink($file);
        } else {
            echo $file.": FEL: filen kunde inte skickas Webdoc."."\n";
        }
    }
}
if($Loop) {
    while(true) {
        foreach ($directorysAndKeys as $clinic) {
            if(!is_dir($clinic['dir'])){
                die($clinic['dir']." is not a directory.");
                continue;
            }
            ScanDirSend($clinic, $maxFileSize);
        }
        sleep($sleep);
    }
} else {
    foreach ($directorysAndKeys as $clinic) {
        if(!is_dir($clinic['dir'])){
            die($clinic['dir']." is not a directory.");
            continue;
        }
        ScanDirSend($clinic, $maxFileSize);
    }
}
?>
